/***************************************************************************
 *   Copyright (C) 2007 by Claudio Scafuri, Giacomo Strangolino   *
 *   claudio@hyo   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <tutil.h>
#include <euniqueapplication.h>
#include <TApplication>
#include "alarm.h"
#include <X11/Xlib.h>
#include <QX11Info>
#include "systray.h"
#include <QDebug>
/* uncomment to set application color */
#include <elettracolors.h>

#define CVSVERSION "$Name:  $"

int main( int argc, char ** argv ) 
{
    char identifier[128];
    QString appname;
    QString version(CVSVERSION);
    appname = QString(argv[0]);
    if(argc > 1)
    	appname += QString("-%1").arg(argv[1]);

    snprintf(identifier, 128, "%s", appname.toStdString().c_str());
    int i;
    for(i = 0; i < strlen(identifier); i++)
    	if(identifier[i] == '/' || identifier[i] == '.')
		identifier[i] = '-';
    

//   EUniqueApplication a( argc, argv, identifier);
    TApplication a(argc, argv);
    a.setApplicationVersion(version);
    a.setProperty("author", "Giacomo");
    a.setProperty("mail", "giacomo.strangolino@elettra.trieste.it");
    a.setProperty("phone", "375-8073");
    a.setProperty("office", "T2PT025");
    a.setProperty("hwReferent", "Graziano"); /* name of the referent that provides the device server */

    SysTray *systray = new SysTray(0);
    Alarm mw(0, systray);
    
    for(int j = 0; j < qApp->arguments().size(); j++)
    {
	if(qApp->arguments().at(j).contains(QRegExp("style\\s*=?\\s*booster")))
	{
		a.setPalette(EPalette("booster"));
		mw.setWindowIcon(QIcon(":icons/booster-alarm.png"));
		break;
	}
        else if(qApp->arguments().at(j).contains(QRegExp("style\\s*=?\\s*elettra")))
	{
	   a.setPalette(EPalette("elettra"));
	   mw.setWindowIcon(QIcon(":icons/elettra-alarm.png"));
	   break;
	}
        else if(qApp->arguments().at(j).contains(QRegExp("style\\s*=?\\s*fermi")))
	{
		a.setPalette(EPalette("fermi"));
		mw.setWindowIcon(QIcon(":icons/fermi-alarm.png"));
		break;
	}
        else
	{
 		qDebug()<< "style = elettra|booster|fermi on the command line if you want to personalize the style";
		a.setPalette(EPalette("elettra"));
	}
    }
	
    systray->attach(&mw);
    systray->setToolTip(QString("%1\nClick to hide/show the main window, right click\nand choose \"Quit Application\" to exit the panel").arg(appname));

    TUtil::instance()->setLoggingTarget(argv[0]);
    mw.show();

    if(argc > 1)
    	mw.setWindowTitle(argv[1]);
    /* register to window manager */
    Display *disp = QX11Info::display();
    Window root_win = (Window) mw.winId();
    XSetCommand(disp, root_win, QApplication::argv(), QApplication::argc());

        /* Finally call UniqueExec() instead of the exec():
     */
//    QObject::connect(&a, SIGNAL(Rise()), &mw, SLOT(raise()));
//    QObject::connect(&a, SIGNAL(Rise()), &mw, SLOT(show()));

//    return a.UniqueExec();
	return a.exec();
}

