#ifndef ALARM_SYSTRAY_H
#define ALARM_SYSTRAY_H

#include <QSystemTrayIcon>

class QMenu;

class SysTray : public QSystemTrayIcon
{
    Q_OBJECT
public:
    SysTray(QObject *parent);
    void attach(QWidget *parent);

    void showMessage(const QString & title,
                     const QString & message,
                     MessageIcon icon = Information,
                     int millisecondsTimeoutHint = 10000 );

private slots:
    void menu(QSystemTrayIcon::ActivationReason);

    void setMessageClicked();

private:
    QWidget *d_parent;
    QMenu *d_menu;

    bool mMessageShown;
};


#endif


